using System.Collections.Generic;
using IdentityServer4.Models;

namespace SampleAuthServer
{
    public static class Config
    {
        public static IEnumerable<ApiResource> GetApiResources() => new List<ApiResource>
        {
            new ApiResource("api1", "My API"),
            new ApiResource("api2", "My API")
        };

        public static IEnumerable<Client> GetClients() => new List<Client>
        {
            new Client
            {
                ClientId = "client",

                AllowedGrantTypes = GrantTypes.ClientCredentials,

                ClientSecrets =
                {
                    new Secret("secret".Sha256())
                },

                AllowedScopes = { "api1", "api2" },

                AccessTokenLifetime = 3
            }
        };
    }
}